using Toybox.WatchUi;
using Toybox.Graphics as Gfx;
using Toybox.System as Sys;
using Toybox.Application as App;
using Toybox.SensorHistory as SH;

class o2View extends WatchUi.View {
	var width, height;
	
    function initialize() {
        View.initialize();
        
        var timer= new Timer.Timer();
		timer.start( method(:onTimer), 1000, true );
		Sensor.setEnabledSensors([Sensor.SENSOR_PULSE_OXIMETRY]);
    }
    
    function onTimer() {
    	WatchUi.requestUpdate();
    }

    // Load your resources here
    function onLayout(dc) {
		width=dc.getWidth();
		height=dc.getHeight();
    }

    // Called when this View is brought to the foreground. Restore
    // the state of this View and prepare it to be shown. This includes
    // loading resources into memory.
    function onShow() {
    }

    // Update the view
    function onUpdate(dc) {
    	dc.setColor(Gfx.COLOR_BLACK, Gfx.COLOR_BLACK);
    	dc.clear();
    	dc.setColor(Gfx.COLOR_WHITE, Gfx.COLOR_TRANSPARENT);
    	var clockTime = System.getClockTime();
    	dc.drawText(width/2,20,Gfx.FONT_SMALL,clockTime.hour.format("%d")+":"+clockTime.min.format("%02d")+":"+clockTime.sec.format("%02d"),Gfx.TEXT_JUSTIFY_CENTER);
    	
    	var si=Sensor.getInfo();   	
    	dc.drawText(width/2,50,Gfx.FONT_SMALL,""+si.oxygenSaturation,Gfx.TEXT_JUSTIFY_CENTER);

		var iter=SH.getOxygenSaturationHistory({:period=>10,:order=>SH.ORDER_NEWEST_FIRST});
    	var min=null;
		var max=null;
		var cur=null;
		var count=0;

		if(iter!=null) {
			min=iter.getMin();
			max=iter.getMax();
			var sample=iter.next();
			if(sample!=null) {
				cur=sample.data;
				count++;
				sample=iter.next();	
			}
			var x=width*.33;
			var y=140;
			while(sample!=null && min!=null && max!=null) {
				count++;
				if(count<=7) {
					dc.drawText(x,y,Gfx.FONT_TINY,""+sample.data.format("%d"),Gfx.TEXT_JUSTIFY_CENTER);
					if(x==width*.33) {
						x=width*.66;
					} else {
						x=width*.33;
						y+=25;
					}
				}
				sample=iter.next();
			}
    	}
    	dc.drawText(width/2,80,Gfx.FONT_SMALL,""+cur,Gfx.TEXT_JUSTIFY_CENTER);
    	dc.drawText(width/2,110,Gfx.FONT_SMALL,""+min.format("%d")+" "+max.format("%d")+" "+count,Gfx.TEXT_JUSTIFY_CENTER);
    }

    // Called when this View is removed from the screen. Save the
    // state of this View here. This includes freeing resources from
    // memory.
    function onHide() {
    }

}
